extends Node2D


# Declare member variables here. Examples:
# var a = 2
# var b = "text"

var pieces = [];
var pieceSprites = [];
# Called when the node enters the scene tree for the first time.
func _ready():
	
	for i in range(36):
		pieces.push_back(Image.new());
		pieces[i].create(460,460,false,Image.FORMAT_RGBA8);
		pieces[i].lock();
		
		pieceSprites.push_back(Sprite.new());
		add_child(pieceSprites[i]);
	
	var mask = Image.new();
	mask = $ViewportMask/TextureRect.texture.get_data();
	mask.flip_x();
	mask.lock();
	
	$ViewportMask.set_clear_mode(Viewport.CLEAR_MODE_ONLY_NEXT_FRAME);
	yield(get_tree(), "idle_frame");
	
	var pieceImage = Image.new();
	pieceImage = $ViewportImage/TextureRect.texture.get_data();
	pieceImage.resize(460,460);
	pieceImage.lock();
	
	$ViewportImage.set_clear_mode(Viewport.CLEAR_MODE_ONLY_NEXT_FRAME);
	yield(get_tree(), "idle_frame");
	
	for i in range (pieceImage.get_width()):
		for j in range (pieceImage.get_height()):
			var rgba255 = mask.get_pixel(i, j) * 255;
			var r = floor (rgba255.r);
			if (r > 0):
				if (rgba255.a == 255 && rgba255.g == rgba255.r && rgba255.b == rgba255.r):
					pieces[r-1].set_pixel(i,j, pieceImage.get_pixel(i,j));
	
	
	$ImageSprite.visible = false;
	for i in range (len(pieces)):
		var pieceTexture = ImageTexture.new();
		pieceTexture.create_from_image(pieces[i]);
		pieceSprites[i].texture = pieceTexture;
		pieceSprites[i].position = Vector2(800,450);
		pieces[i].unlock();
	
	mask.unlock();
	pieceImage.unlock();


# Called every frame. 'delta' is the elapsed time since the previous frame.
#func _process(delta):
#	pass
